
;CodeVisionAVR C Compiler V2.04.4a Advanced
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATtiny45
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 64 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATtiny45
	#pragma AVRPART MEMORY PROG_FLASH 4096
	#pragma AVRPART MEMORY EEPROM 256
	#pragma AVRPART MEMORY INT_SRAM SIZE 256
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E

	.EQU WDTCR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x11
	.EQU GPIOR1=0x12
	.EQU GPIOR2=0x13

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP _ext_int0_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_Sparks:
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC
	.DB  0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x33
	.DB  0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC

_0x3:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0
__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x100)
	LDI  R25,HIGH(0x100)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GPIOR0-GPIOR2 INITIALIZATION
	LDI  R30,0x00
	OUT  GPIOR0,R30
	OUT  GPIOR1,R30
	OUT  GPIOR2,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x15F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x15F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xA0)
	LDI  R29,HIGH(0xA0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xA0

	.CSEG
;/*****************************************************
; : Omicron
; : 4.0
;  : Klingfed
; : 
;
;               : ATtiny45
;       : 8 M
;          : Tiny
;  SRAM  : 0
;     : 64
;*****************************************************/
;
;#include <tiny45.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x18
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x18
	.SET power_ctrl_reg=mcucr
	#endif
;
;//   
;volatile unsigned char Flag=0;
;#include "Box.c"
;flash unsigned char Sparks[128][8] = {
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100},
; {0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011, 0b00110011},
; {0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100, 0b11001100}
;};
;
;//    
;interrupt [EXT_INT0] void ext_int0_isr(void)
; 0000 0016 {

	.CSEG
_ext_int0_isr:
	ST   -Y,R30
; 0000 0017  Flag = 1; // 
	LDI  R30,LOW(1)
	STS  _Flag,R30
; 0000 0018 }
	LD   R30,Y+
	RETI
;
;void main(void)
; 0000 001B {
_main:
; 0000 001C //   
; 0000 001D unsigned char i=0, j=0, k=0;
; 0000 001E unsigned long int Tau=0, Delay=0, n=0;
; 0000 001F 
; 0000 0020 //   : 1
; 0000 0021 #pragma optsize-
; 0000 0022 CLKPR=0x80;
	SBIW R28,12
	LDI  R24,12
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x3*2)
	LDI  R31,HIGH(_0x3*2)
	RCALL __INITLOCB
;	i -> R17
;	j -> R16
;	k -> R19
;	Tau -> Y+8
;	Delay -> Y+4
;	n -> Y+0
	LDI  R17,0
	LDI  R16,0
	LDI  R19,0
	LDI  R30,LOW(128)
	OUT  0x26,R30
; 0000 0023 CLKPR=0x00;
	LDI  R30,LOW(0)
	OUT  0x26,R30
; 0000 0024 #ifdef _OPTIMIZE_SIZE_
; 0000 0025 #pragma optsize+
; 0000 0026 #endif
; 0000 0027 
; 0000 0028 //   /
; 0000 0029 //   B
; 0000 002A //      B: 5=Out; 4=Out; 3=Out; 2=Out; 1=Out; 0=In;
; 0000 002B // C   B: 5=0 4=0; 3=0; 2=0; 1=0; 0=T;
; 0000 002C DDRB=0x3E;
	LDI  R30,LOW(62)
	OUT  0x17,R30
; 0000 002D PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 002E 
; 0000 002F //  / 0
; 0000 0030 //   :   
; 0000 0031 //  :  0 
; 0000 0032 //  : Normal top=FFh
; 0000 0033 // OC0A : 
; 0000 0034 // OC0B : 
; 0000 0035 TCCR0A=0x00;
	OUT  0x2A,R30
; 0000 0036 TCCR0B=0x00;
	OUT  0x33,R30
; 0000 0037 TCNT0=0x00;
	OUT  0x32,R30
; 0000 0038 OCR0A=0x00;
	OUT  0x29,R30
; 0000 0039 OCR0B=0x00;
	OUT  0x28,R30
; 0000 003A 
; 0000 003B //  / 1
; 0000 003C //   :   
; 0000 003D //  :  1 
; 0000 003E //  : Normal top=FFh
; 0000 003F // OC1A : 
; 0000 0040 // OC1B : 
; 0000 0041 //   1  : 
; 0000 0042 //       A: 
; 0000 0043 //       B: 
; 0000 0044 PLLCSR=0x00;
	OUT  0x27,R30
; 0000 0045 
; 0000 0046 TCCR1=0x00;
	OUT  0x30,R30
; 0000 0047 GTCCR=0x00;
	OUT  0x2C,R30
; 0000 0048 TCNT1=0x00;
	OUT  0x2F,R30
; 0000 0049 OCR1A=0x00;
	OUT  0x2E,R30
; 0000 004A OCR1B=0x00;
	OUT  0x2B,R30
; 0000 004B OCR1C=0x00;
	OUT  0x2D,R30
; 0000 004C 
; 0000 004D //   
; 0000 004E // INT0: 
; 0000 004F //   INT0:  
; 0000 0050 //       PCINT0-5: 
; 0000 0051 GIMSK=0x40;
	LDI  R30,LOW(64)
	OUT  0x3B,R30
; 0000 0052 MCUCR=0x03;
	LDI  R30,LOW(3)
	OUT  0x35,R30
; 0000 0053 GIFR=0x40;
	LDI  R30,LOW(64)
	OUT  0x3A,R30
; 0000 0054 
; 0000 0055 //    /
; 0000 0056 TIMSK=0x00;
	LDI  R30,LOW(0)
	OUT  0x39,R30
; 0000 0057 
; 0000 0058 //     (USI)
; 0000 0059 //  : 
; 0000 005A //   : Register & Counter=no clk.
; 0000 005B //   USI  : 
; 0000 005C USICR=0x00;
	OUT  0xD,R30
; 0000 005D 
; 0000 005E //   
; 0000 005F //  : 
; 0000 0060 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 0061 ADCSRB=0x00;
	LDI  R30,LOW(0)
	OUT  0x3,R30
; 0000 0062 
; 0000 0063 //  
; 0000 0064 #asm("sei")
	sei
; 0000 0065 
; 0000 0066 while (1){
_0x4:
; 0000 0067       Mark: ; //      
_0x7:
; 0000 0068        if (Flag==1) { // ,      
	LDS  R26,_Flag
	CPI  R26,LOW(0x1)
	BRNE _0x8
; 0000 0069         PORTB=0x00; //   
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 006A         if (i<=128) { //    
	CPI  R17,129
	BRSH _0x9
; 0000 006B          Delay -= ((128-i)*Delay)>>7; //       
	RCALL SUBOPT_0x0
	LDI  R26,LOW(128)
	LDI  R27,HIGH(128)
	SUB  R26,R30
	SBC  R27,R31
	RCALL SUBOPT_0x1
	RCALL __CWD2
	RCALL __MULD12U
	MOVW R26,R30
	MOVW R24,R22
	RCALL SUBOPT_0x2
	RCALL __SUBD21
	__PUTD2S 4
; 0000 006C         } else {
	RJMP _0xA
_0x9:
; 0000 006D          Delay += Tau>>7; //      
	__GETD2S 8
	RCALL SUBOPT_0x2
	RCALL __ADDD12
	__PUTD1S 4
; 0000 006E         };
_0xA:
; 0000 006F        Flag = 0; // 
	LDI  R30,LOW(0)
	STS  _Flag,R30
; 0000 0070        };
_0x8:
; 0000 0071 
; 0000 0072       for (i=0;i<128;i++) {
	LDI  R17,LOW(0)
_0xC:
	CPI  R17,128
	BRLO PC+2
	RJMP _0xD
; 0000 0073        PORTB=0x00; //   ,  ,  
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 0074        PORTB.3 = 1; //    RESET 
	SBI  0x18,3
; 0000 0075 
; 0000 0076        for (j=0;j<8;j++) {
	LDI  R16,LOW(0)
_0x11:
	CPI  R16,8
	BRSH _0x12
; 0000 0077         for (k=0;k<8;k++) {
	LDI  R19,LOW(0)
_0x14:
	CPI  R19,8
	BRSH _0x15
; 0000 0078          PORTB.1 = ((Sparks[i][j]>>k)&(0x01)); //       
	RCALL SUBOPT_0x0
	RCALL __LSLW3
	SUBI R30,LOW(-_Sparks*2)
	SBCI R31,HIGH(-_Sparks*2)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	LPM  R26,Z
	LDI  R27,0
	MOV  R30,R19
	RCALL __ASRW12
	ANDI R30,LOW(0x1)
	BRNE _0x16
	CBI  0x18,1
	RJMP _0x17
_0x16:
	SBI  0x18,1
_0x17:
; 0000 0079          PORTB.2 = 1; //          
	SBI  0x18,2
; 0000 007A          PORTB.2 = 0;
	CBI  0x18,2
; 0000 007B         };
	SUBI R19,-1
	RJMP _0x14
_0x15:
; 0000 007C        };
	SUBI R16,-1
	RJMP _0x11
_0x12:
; 0000 007D        PORTB.4 = 1; // 
	SBI  0x18,4
; 0000 007E 
; 0000 007F        for (n=0;n<Delay;n++) { //       
	LDI  R30,LOW(0)
	RCALL __CLRD1S0
_0x1F:
	RCALL SUBOPT_0x1
	RCALL __GETD2S0
	RCALL __CPD21
	BRSH _0x20
; 0000 0080         if (Flag==1) { // ,      
	LDS  R26,_Flag
	CPI  R26,LOW(0x1)
	BRNE _0x21
; 0000 0081          goto Mark; //    
	RJMP _0x7
; 0000 0082         }
; 0000 0083        };
_0x21:
	RCALL __GETD1S0
	RCALL SUBOPT_0x3
	RCALL __PUTD1S0
	RJMP _0x1F
_0x20:
; 0000 0084       };
	SUBI R17,-1
	RJMP _0xC
_0xD:
; 0000 0085 
; 0000 0086       for (Tau=0;Flag==0;Tau++) { //     
	LDI  R30,LOW(0)
	__CLRD1S 8
_0x23:
	LDS  R30,_Flag
	CPI  R30,0
	BRNE _0x24
; 0000 0087       };
	__GETD1S 8
	RCALL SUBOPT_0x3
	__PUTD1S 8
	RJMP _0x23
_0x24:
; 0000 0088 
; 0000 0089      };
	RJMP _0x4
; 0000 008A }
_0x25:
	RJMP _0x25
;

	.DSEG
_Flag:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	MOV  R30,R17
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	__GETD1S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(7)
	RCALL __LSRD12
	__GETD2S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3:
	__SUBD1N -1
	RET


	.CSEG
__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__SUBD21:
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R25,R23
	RET

__ASRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __ASRW12R
__ASRW12L:
	ASR  R31
	ROR  R30
	DEC  R0
	BRNE __ASRW12L
__ASRW12R:
	RET

__LSRD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSRD12R
__LSRD12L:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRD12L
__LSRD12R:
	RET

__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__CWD2:
	MOV  R24,R27
	ADD  R24,R24
	SBC  R24,R24
	MOV  R25,R24
	RET

__MULD12U:
	PUSH R19
	PUSH R20
	PUSH R21
	LDI  R21,33
	MOV  R0,R26
	MOV  R1,R27
	MOV  R19,R24
	MOV  R20,R25
	CLR  R26
	CLR  R27
	CLR  R24
	SUB  R25,R25
	RJMP __MULD12U1
__MULD12U3:
	BRCC __MULD12U2
	ADD  R26,R0
	ADC  R27,R1
	ADC  R24,R19
	ADC  R25,R20
__MULD12U2:
	LSR  R25
	ROR  R24
	ROR  R27
	ROR  R26
__MULD12U1:
	ROR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __MULD12U3
	POP  R21
	POP  R20
	POP  R19
	RET

__GETD1S0:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R22,Y+2
	LDD  R23,Y+3
	RET

__GETD2S0:
	LD   R26,Y
	LDD  R27,Y+1
	LDD  R24,Y+2
	LDD  R25,Y+3
	RET

__PUTD1S0:
	ST   Y,R30
	STD  Y+1,R31
	STD  Y+2,R22
	STD  Y+3,R23
	RET

__CLRD1S0:
	ST   Y,R30
	STD  Y+1,R30
	STD  Y+2,R30
	STD  Y+3,R30
	RET

__CPD21:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R25,R23
	RET

__INITLOCB:
__INITLOCW:
	ADD  R26,R28
	ADC  R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
